## protozero 1.2.3

=== Makefile ===
# first inherit from env
CXX := $(CXX)
CXXFLAGS := $(CXXFLAGS)
LDFLAGS := $(LDFLAGS)

WARNING_FLAGS := -Wall -Wextra -pedantic -Wsign-compare -Wsign-conversion -Wunused-parameter -Wno-float-equal -Wno-covered-switch-default

ifneq ($(findstring clang,$(CXX)),)
    WARNING_FLAGS += -Wno-reserved-id-macro -Weverything -Wno-weak-vtables -Wno-c++98-compat -Wno-c++98-compat-pedantic -Wno-exit-time-destructors -Wno-switch-enum -Wno-padded -Wno-documentation-unknown-command
endif

COMMON_FLAGS := -fvisibility-inlines-hidden -std=c++11 $(WARNING_FLAGS)

RELEASE_FLAGS := -O3 -DNDEBUG -march=native
DEBUG_FLAGS := -O0 -g -fno-inline-functions
PTHREAD_FLAGS =

OS:=$(shell uname -s)

ifeq ($(OS),Linux)
    PTHREAD_FLAGS = -pthread
endif

ifeq ($(OS),Darwin)
    CXXFLAGS += -stdlib=libc++
    LDFLAGS += -stdlib=libc++
endif

TEST_CASES := $(wildcard test/t/*/test_cases.cpp)
TEST_CASES_O := $(subst .cpp,.o,$(TEST_CASES))

WRITER_TEST_CASES := $(wildcard test/t/*/writer_test_cases.cpp)
WRITER_TEST_CASES_O := $(subst .cpp,.o,$(WRITER_TEST_CASES))

PROTO_FILES := $(subst writer_test_cases.cpp,testcase.proto,$(WRITER_TEST_CASES))
PROTO_FILES_CC := $(subst .proto,.pb.cc,$(PROTO_FILES))
PROTO_FILES_H := $(subst .proto,.pb.h,$(PROTO_FILES))
PROTO_FILES_O := $(subst .proto,.pb.o,$(PROTO_FILES))

HPP_FILES := include/protozero/byteswap.hpp \
             include/protozero/exception.hpp \
             include/protozero/varint.hpp \
             include/protozero/pbf_types.hpp \
             include/protozero/pbf_reader.hpp \
             include/protozero/pbf_writer.hpp

CFLAGS_PROTOBUF := $(subst -I,-isystem ,$(shell pkg-config protobuf --cflags))
LDFLAGS_PROTOBUF := $(shell pkg-config protobuf --libs-only-L)

all: ./test/tests test/writer_tests

./test/t/%/test_cases.o: test/t/%/test_cases.cpp $(HPP_FILES)
	$(CXX) -c -Iinclude -Itest/include $(CXXFLAGS) $(COMMON_FLAGS) $(DEBUG_FLAGS) $< -o $@

./test/tests.o: test/tests.cpp $(HPP_FILES)
	$(CXX) -c -Iinclude -Itest/include $(CXXFLAGS) $(COMMON_FLAGS) $(DEBUG_FLAGS) $< -o $@

./test/tests: test/tests.o $(TEST_CASES_O)
	$(CXX) $(LDFLAGS) $^ -o $@

./test/t/%/testcase.pb.cc: ./test/t/%/testcase.proto
	protoc --cpp_out=. $^

./test/t/%/testcase.pb.o: ./test/t/%/testcase.pb.cc
	$(CXX) -c -I. -Iinclude -Itest/include $(CXXFLAGS) $(CFLAGS_PROTOBUF) -std=c++11 $(DEBUG_FLAGS) $< -o $@

./test/t/%/writer_test_cases.o: ./test/t/%/writer_test_cases.cpp $(HPP_FILES)
	$(CXX) -c -I. -Iinclude -Itest/include $(CXXFLAGS) $(CFLAGS_PROTOBUF) $(COMMON_FLAGS) $(DEBUG_FLAGS) $< -o $@

./test/writer_tests.o: test/writer_tests.cpp $(HPP_FILES) $(PROTO_FILES_CC)
	$(CXX) -c -I. -Iinclude -Itest/include $(CXXFLAGS) $(COMMON_FLAGS) $(DEBUG_FLAGS) $< -o $@

./test/writer_tests: test/writer_tests.o $(PROTO_FILES_O) $(WRITER_TEST_CASES_O)
	$(CXX) $(LDFLAGS) $(LDFLAGS_PROTOBUF) $^ -lprotobuf-lite $(PTHREAD_FLAGS) -o $@

test: all
	./test/tests
	./test/writer_tests

iwyu: $(HPP_FILES) test/tests.cpp test/writer_tests.cpp
	iwyu -Xiwyu -- -std=c++11 -Iinclude include/protozero/exception.hpp || true
	iwyu -Xiwyu -- -std=c++11 -Iinclude include/protozero/varint.hpp || true
	iwyu -Xiwyu -- -std=c++11 -Iinclude include/protozero/pbf_types.hpp || true
	iwyu -Xiwyu -- -std=c++11 -Iinclude include/protozero/pbf_reader.hpp || true
	iwyu -Xiwyu -- -std=c++11 -Iinclude include/protozero/pbf_writer.hpp || true
	iwyu -Xiwyu -- -std=c++11 -Iinclude -Itest/include test/tests.cpp || true
	iwyu -Xiwyu -- -std=c++11 -Iinclude -Itest/include test/writer_tests.cpp || true

check: $(HPP_FILES) test/tests.cpp test/include/test.hpp test/include/testcase.hpp test/t/*/testcase.cpp $(TEST_CASES)
	cppcheck -Uassert --std=c++11 --enable=all --suppress=incorrectStringBooleanError $^

doc: doc/Doxyfile README.md tutorial.md $(HPP_FILES)
	doxygen doc/Doxyfile

clean:
	rm -f ./test/tests
	rm -f ./test/tests.o
	rm -f ./test/tests.gc*
	rm -f ./test/writer_tests
	rm -f ./test/writer_tests.o
	rm -f ./test/writer_tests.gc*
	rm -f ./test/t/*/testcase.pb.cc
	rm -f ./test/t/*/testcase.pb.h
	rm -f ./test/t/*/testcase.pb.o
	rm -f ./test/t/*/testcase.pb.gc*
	rm -f ./test/t/*/testcase.o
	rm -f ./test/t/*/testcase
	rm -f ./test/t/*/test_cases.o
	rm -f ./test/t/*/test_cases.gc*
	rm -f ./test/t/*/writer_test_cases.o
	rm -f ./test/t/*/writer_test_cases.gc*
	rm -f ./*.gcov
	rm -fr doc/doxygen_sqlite3.db doc/html coverage

.PHONY: all test iwyu check doc

=== debian/changelog ===
protozero (1.2.3-1) unstable; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 01 Dec 2015 09:14:44 +0100

protozero (1.2.2-1) unstable; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 13 Oct 2015 09:08:19 +0200

protozero (1.2.1-1) unstable; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 12 Oct 2015 22:30:21 +0200

protozero (1.2.0-1) unstable; urgency=medium

  * New upstream release.
  * Update Vcs-Browser URL to use HTTPS.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 12 Oct 2015 08:18:37 +0200

protozero (1.1.0-5) unstable; urgency=medium

  * Fix Breaks/Replaces to use less then versions only.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 02 Sep 2015 21:36:48 +0200

protozero (1.1.0-4) unstable; urgency=medium

  * Ignore test failures only on problematic architectures.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 02 Sep 2015 16:17:13 +0200

protozero (1.1.0-3) unstable; urgency=medium

  * Use Breaks/Replaces for libosmium2-dev versions including protozero only.
  * Ignore test failures to not fail the entire build.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 02 Sep 2015 13:29:03 +0200

protozero (1.1.0-2) unstable; urgency=medium

  * Add license & copyright for test/include/catch.hpp.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 01 Sep 2015 14:53:24 +0200

protozero (1.1.0-1) unstable; urgency=medium

  * New upstream release.
  * Install CHANGELOG.md as upstream changelog.
  * Use versioned Breaks instead of Conflicts for libosmium2-dev.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 22 Aug 2015 22:09:29 +0200

protozero (1.0.0-1) unstable; urgency=medium

  * Initial release (Closes: #796508)

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 22 Aug 2015 11:41:42 +0200

=== debian/control ===
Source: protozero
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Bas Couwenberg <sebastic@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               doxygen,
               graphviz,
               libprotobuf-dev,
               protobuf-compiler,
               pkg-config
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/protozero.git/
Vcs-Git: git://anonscm.debian.org/pkg-grass/protozero.git
Homepage: https://github.com/mapbox/protozero

Package: libprotozero-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}
Breaks: libosmium2-dev (<< 2.4.1-2~)
Replaces: libosmium2-dev (<< 2.4.1-2~)
Suggests: protozero-doc
Description: Minimalistic protocol buffer decoder and encoder in C++
 protozero is a minimalistic protocol buffer decoder and encoder in C++.
 .
 Designed for high performance. Suitable for writing zero copy parsers
 and encoders with minimal need for run-time allocation of memory.
 .
 Low-level: this is designed to be a building block for writing a very
 customized decoder for a stable protobuf schema. If your protobuf schema
 is changing frequently or lazy decoding is not critical for your
 application then this approach offers no value: just use the decoding
 API available via the C++ API that can be generated via the Google
 Protobufs protoc program.
 .
 This package contains the protozero headers.

Package: libprotozero-doc
Architecture: all
Section: doc
Depends: libjs-jquery,
         ${misc:Depends}
Description: Minimalistic protocol buffer decoder and encoder in C++ - docs
 protozero is a minimalistic protocol buffer decoder and encoder in C++.
 .
 Designed for high performance. Suitable for writing zero copy parsers
 and encoders with minimal need for run-time allocation of memory.
 .
 Low-level: this is designed to be a building block for writing a very
 customized decoder for a stable protobuf schema. If your protobuf schema
 is changing frequently or lazy decoding is not critical for your
 application then this approach offers no value: just use the decoding
 API available via the C++ API that can be generated via the Google
 Protobufs protoc program.
 .
 This package contains the protozero documentation.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

# Verbose make output
export VERBOSE=1

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

%:
	dh $@ --parallel

override_dh_auto_build-arch:
	dh_auto_build --arch

override_dh_auto_build-indep:
	$(MAKE) doc
	# Remove useless autogenerated doxygen files
	$(RM) doc/html/*.md5

override_dh_auto_test:
# Ignore test failures on problematic architectures only
ifneq (,$(findstring $(DEB_BUILD_ARCH),"armhf"))
	dh_auto_test || echo "Ignoring test failures"
else
	dh_auto_test
endif

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG.md

=== debian/watch ===
version=3
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,\
filenamemangle=s/(?:.*)?v(\d[\d\.]*)\.(tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))/protozero-$1.$2/ \
https://github.com/mapbox/protozero/releases \
(?:.*/)?(?:rel|v|protozero)[\-\_]?(\d[\d\-\.]+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## protozero 1.3.0

=== debian/changelog ===
protozero (1.3.0-1) unstable; urgency=medium

  * New upstream release.
  * Update Vcs-Git URL to use HTTPS.
  * Bump Standards-Version to 3.9.7, no changes.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 19 Feb 2016 11:36:58 +0100

=== debian/control ===
--- 
+++ 
@@ -9,9 +9,9 @@
                libprotobuf-dev,
                protobuf-compiler,
                pkg-config
-Standards-Version: 3.9.6
+Standards-Version: 3.9.7
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/protozero.git/
-Vcs-Git: git://anonscm.debian.org/pkg-grass/protozero.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-grass/protozero.git
 Homepage: https://github.com/mapbox/protozero
 
 Package: libprotozero-dev

## protozero 1.4.0

=== Makefile ===
--- 
+++ 
@@ -2,6 +2,9 @@
 CXX := $(CXX)
 CXXFLAGS := $(CXXFLAGS)
 LDFLAGS := $(LDFLAGS)
+
+# Installation directory
+DESTDIR ?= /usr
 
 WARNING_FLAGS := -Wall -Wextra -pedantic -Wsign-compare -Wsign-conversion -Wunused-parameter -Wno-float-equal -Wno-covered-switch-default
 
@@ -38,18 +41,25 @@
 PROTO_FILES_O := $(subst .proto,.pb.o,$(PROTO_FILES))
 
 HPP_FILES := include/protozero/byteswap.hpp \
+             include/protozero/config.hpp \
              include/protozero/exception.hpp \
+             include/protozero/iterators.hpp \
+             include/protozero/pbf_builder.hpp \
+             include/protozero/pbf_message.hpp \
+             include/protozero/pbf_reader.hpp \
+             include/protozero/pbf_writer.hpp \
+             include/protozero/types.hpp \
              include/protozero/varint.hpp \
-             include/protozero/pbf_types.hpp \
-             include/protozero/pbf_reader.hpp \
-             include/protozero/pbf_writer.hpp
+             include/protozero/version.hpp
+
+DOC_FILES = doc/cheatsheet.md doc/macros.md doc/tutorial.md
 
 CFLAGS_PROTOBUF := $(subst -I,-isystem ,$(shell pkg-config protobuf --cflags))
 LDFLAGS_PROTOBUF := $(shell pkg-config protobuf --libs-only-L)
 
 all: ./test/tests test/writer_tests
 
-./test/t/%/test_cases.o: test/t/%/test_cases.cpp $(HPP_FILES)
+./test/t/%/test_cases.o: test/t/%/test_cases.cpp test/include/test.hpp test/include/scalar_access.hpp test/include/packed_access.hpp $(HPP_FILES)
 	$(CXX) -c -Iinclude -Itest/include $(CXXFLAGS) $(COMMON_FLAGS) $(DEBUG_FLAGS) $< -o $@
 
 ./test/tests.o: test/tests.cpp $(HPP_FILES)
@@ -79,8 +89,8 @@
 
 iwyu: $(HPP_FILES) test/tests.cpp test/writer_tests.cpp
 	iwyu -Xiwyu -- -std=c++11 -Iinclude include/protozero/exception.hpp || true
+	iwyu -Xiwyu -- -std=c++11 -Iinclude include/protozero/types.hpp || true
 	iwyu -Xiwyu -- -std=c++11 -Iinclude include/protozero/varint.hpp || true
-	iwyu -Xiwyu -- -std=c++11 -Iinclude include/protozero/pbf_types.hpp || true
 	iwyu -Xiwyu -- -std=c++11 -Iinclude include/protozero/pbf_reader.hpp || true
 	iwyu -Xiwyu -- -std=c++11 -Iinclude include/protozero/pbf_writer.hpp || true
 	iwyu -Xiwyu -- -std=c++11 -Iinclude -Itest/include test/tests.cpp || true
@@ -89,7 +99,7 @@
 check: $(HPP_FILES) test/tests.cpp test/include/test.hpp test/include/testcase.hpp test/t/*/testcase.cpp $(TEST_CASES)
 	cppcheck -Uassert --std=c++11 --enable=all --suppress=incorrectStringBooleanError $^
 
-doc: doc/Doxyfile README.md tutorial.md $(HPP_FILES)
+doc: doc/Doxyfile README.md UPGRADING.md $(DOC_FILES) $(HPP_FILES)
 	doxygen doc/Doxyfile
 
 clean:
@@ -112,5 +122,15 @@
 	rm -f ./*.gcov
 	rm -fr doc/doxygen_sqlite3.db doc/html coverage
 
+testpack:
+	rm -f ./*tgz
+	npm pack
+	tar -ztvf *tgz
+	rm -f ./*tgz
+
+install:
+	install -m 0755 -o root -g root -d $(DESTDIR)/include/protozero
+	install -m 0644 -o root -g root include/protozero/* $(DESTDIR)/include/protozero
+
 .PHONY: all test iwyu check doc

=== debian/changelog ===
protozero (1.4.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 3.9.8, no changes.
  * Update watch file to handle more tag conventions in filenamemangle.
  * Override dh_auto_install to set appropriate DESTDIR.
  * Override dh_install to use --list-install.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 22 Jul 2016 16:29:25 +0200

## protozero 1.4.5

=== Makefile ===
--- 
+++ 
@@ -6,7 +6,7 @@
 # Installation directory
 DESTDIR ?= /usr
 
-WARNING_FLAGS := -Wall -Wextra -pedantic -Wsign-compare -Wsign-conversion -Wunused-parameter -Wno-float-equal -Wno-covered-switch-default
+WARNING_FLAGS := -Wall -Wextra -pedantic -Wsign-compare -Wsign-conversion -Wunused-parameter -Wno-float-equal -Wno-covered-switch-default -Wshadow
 
 ifneq ($(findstring clang,$(CXX)),)
     WARNING_FLAGS += -Wno-reserved-id-macro -Weverything -Wno-weak-vtables -Wno-c++98-compat -Wno-c++98-compat-pedantic -Wno-exit-time-destructors -Wno-switch-enum -Wno-padded -Wno-documentation-unknown-command

## protozero 1.5.1

=== Makefile ===
--- 
+++ 
@@ -52,7 +52,7 @@
              include/protozero/varint.hpp \
              include/protozero/version.hpp
 
-DOC_FILES = doc/cheatsheet.md doc/macros.md doc/tutorial.md
+DOC_FILES = doc/advanced.md doc/cheatsheet.md doc/tutorial.md
 
 CFLAGS_PROTOBUF := $(subst -I,-isystem ,$(shell pkg-config protobuf --cflags))
 LDFLAGS_PROTOBUF := $(shell pkg-config protobuf --libs-only-L)

=== debian/changelog ===
protozero (1.5.1-1+deb9u1) stretch; urgency=medium

  * Update branch in gbp.conf & Vcs-Git URL.
  * Include upstream patch to fix data_view equality operator.
    This fixes a rather embarrassing bug in the equality operator of the
    data_view class. The equality operator is actually never used in the
    protozero code itself, but users of protozero might use it. This is a
    serious bug that could lead to buffer overrun type problems.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 01 Jul 2017 15:59:15 +0200

protozero (1.5.1-1) unstable; urgency=medium

  * New upstream release.
  * Drop makefile-docs.patch, applied upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 14 Jan 2017 11:19:51 +0100

protozero (1.5.0-1) unstable; urgency=medium

  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 12 Jan 2017 19:25:52 +0100

protozero (1.5.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Include additional docs in libprotozero-dev.
  * Add patch to update DOC_FILES to fix `make doc` failure.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 12 Jan 2017 14:29:29 +0100

protozero (1.4.5-1) unstable; urgency=medium

  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 21 Nov 2016 07:15:23 +0100

protozero (1.4.5-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 18 Nov 2016 16:12:38 +0100

protozero (1.4.4-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Drop 0001-Fixed-byteswap-implementation.patch, included upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 15 Nov 2016 22:16:28 +0100

protozero (1.4.3-1~exp2) experimental; urgency=medium

  * Add upstream patch to fix FTBFS on big endian architectures.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 15 Nov 2016 20:41:25 +0100

protozero (1.4.3-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 15 Nov 2016 14:46:55 +0100

protozero (1.4.2-1) unstable; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 27 Aug 2016 09:58:57 +0200

protozero (1.4.1-1) unstable; urgency=medium

  * New upstream release.
  * Drop © character from copyright statement in copyright file.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 22 Aug 2016 07:34:50 +0200

=== debian/control ===
--- 
+++ 
@@ -9,9 +9,9 @@
                libprotobuf-dev,
                protobuf-compiler,
                pkg-config
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/protozero.git/
-Vcs-Git: https://anonscm.debian.org/git/pkg-grass/protozero.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-grass/protozero.git -b stretch
 Homepage: https://github.com/mapbox/protozero
 
 Package: libprotozero-dev

=== debian/rules ===
--- 
+++ 
@@ -26,6 +26,12 @@
 	dh_auto_test
 endif
 
+override_dh_auto_install:
+	dh_auto_install --destdir=$(CURDIR)/debian/tmp/usr
+
+override_dh_install:
+	dh_install --list-missing
+
 override_dh_installchangelogs:
 	dh_installchangelogs CHANGELOG.md

## protozero 1.5.2

=== debian/changelog ===
protozero (1.5.2-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.0.0, no changes.
  * Add autopkgtest to test installability.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 01 Jul 2017 11:05:12 +0200

=== debian/control ===
--- 
+++ 
@@ -9,9 +9,9 @@
                libprotobuf-dev,
                protobuf-compiler,
                pkg-config
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/protozero.git/
-Vcs-Git: https://anonscm.debian.org/git/pkg-grass/protozero.git -b stretch
+Vcs-Git: https://anonscm.debian.org/git/pkg-grass/protozero.git
 Homepage: https://github.com/mapbox/protozero
 
 Package: libprotozero-dev

## protozero 1.6.1

=== CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake config
#
#  protozero
#
#-----------------------------------------------------------------------------

cmake_minimum_required(VERSION 2.8 FATAL_ERROR)

#-----------------------------------------------------------------------------

project(protozero)

set(PROTOZERO_VERSION_MAJOR 1)
set(PROTOZERO_VERSION_MINOR 6)
set(PROTOZERO_VERSION_PATCH 1)

set(PROTOZERO_VERSION
    "${PROTOZERO_VERSION_MAJOR}.${PROTOZERO_VERSION_MINOR}.${PROTOZERO_VERSION_PATCH}")

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

#-----------------------------------------------------------------------------

option(WERROR "Add -Werror flag to build (turns warnings into errors)" ON)

if(MSVC)
    add_definitions(-std=c++11 /W3)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS)
else()
    add_definitions(-std=c++11 -Wall -Wextra -pedantic -Wsign-compare -Wunused-parameter -Wno-float-equal -Wno-covered-switch-default)
    if(WERROR)
        add_definitions(-Werror)
    endif()
endif()

include_directories("${CMAKE_SOURCE_DIR}/include")

set(PROTOZERO_DATA_VIEW "" CACHE STRING "Type used for protozero::data_view")
if(NOT PROTOZERO_DATA_VIEW STREQUAL "")
    add_definitions(-DPROTOZERO_DATA_VIEW=${PROTOZERO_DATA_VIEW})
endif()


#-----------------------------------------------------------------------------
#
#  Find dependencies
#
#-----------------------------------------------------------------------------

find_package(Protobuf)


#-----------------------------------------------------------------------------
#
#  Optional "clang-tidy" target
#
#-----------------------------------------------------------------------------
message(STATUS "Looking for clang-tidy")
find_program(CLANG_TIDY NAMES clang-tidy clang-tidy-5.0)

if(CLANG_TIDY)
    message(STATUS "Looking for clang-tidy - found ${CLANG_TIDY}")
    add_custom_target(clang-tidy
        ${CLANG_TIDY}
        -p ${CMAKE_BINARY_DIR}
        ${CMAKE_SOURCE_DIR}/test/*.cpp
        ${CMAKE_SOURCE_DIR}/test/t/*/reader_test_cases.cpp
        ${CMAKE_SOURCE_DIR}/test/t/*/writer_test_cases.cpp
        ${CMAKE_SOURCE_DIR}/tools/*.cpp
    )
    add_dependencies(clang-tidy writer_tests)
else()
    message(STATUS "Looking for clang-tidy - not found")
    message(STATUS "  Build target 'clang-tidy' will not be available.")
endif()


#-----------------------------------------------------------------------------
#
#  Optional "cppcheck" target
#
#-----------------------------------------------------------------------------
message(STATUS "Looking for cppcheck")
find_program(CPPCHECK NAMES cppcheck)

if(CPPCHECK)
    message(STATUS "Looking for cppcheck - found")
    add_custom_target(cppcheck
        ${CPPCHECK}
        -Uassert --std=c++11 --enable=all
        ${CMAKE_SOURCE_DIR}/include/protozero/*.hpp
        ${CMAKE_SOURCE_DIR}/test/*.cpp
        ${CMAKE_SOURCE_DIR}/test/include/*.hpp
        ${CMAKE_SOURCE_DIR}/test/t/*/*.cpp
        ${CMAKE_SOURCE_DIR}/tools/*.cpp
    )
else()
    message(STATUS "Looking for cppcheck - not found")
    message(STATUS "  Build target 'cppcheck' will not be available.")
endif()


#-----------------------------------------------------------------------------
#
#  Include what you use
#
#-----------------------------------------------------------------------------
message(STATUS "Looking for iwyu")
find_program(IWYU_TOOL NAMES iwyu_tool)

if(IWYU_TOOL)
    message(STATUS "Looking for iwyu - found")
    add_custom_target(iwyu
        ${IWYU_TOOL} -p ${CMAKE_BINARY_DIR}
    )
else()
    message(STATUS "Looking for iwyu - not found")
    message(STATUS "  Build target 'iwyu' will not be available.")
endif()


#-----------------------------------------------------------------------------
#
#  Installation
#
#-----------------------------------------------------------------------------

install(DIRECTORY include/protozero DESTINATION include)


#-----------------------------------------------------------------------------

enable_testing()

add_subdirectory(doc)

add_subdirectory(tools)

add_subdirectory(test)


#-----------------------------------------------------------------------------

=== doc/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  protozero documentation
#
#-----------------------------------------------------------------------------

message(STATUS "Configuring documentation")

message(STATUS "Looking for doxygen")
find_package(Doxygen)

if(DOXYGEN_FOUND)
    message(STATUS "Looking for doxygen - found")
    configure_file(Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)

    file(GLOB HEADER_FILES "${CMAKE_SOURCE_DIR}/include/protozero/*.hpp")
    add_custom_command(OUTPUT html/index.html
        COMMAND ${DOXYGEN_EXECUTABLE}
        ARGS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
        DEPENDS Doxyfile.in advanced.md cheatsheet.md tutorial.md
                ${HEADER_FILES}
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        COMMENT "Generating API documentation with Doxygen" VERBATIM)
    add_custom_target(doc ALL
                      DEPENDS html/index.html)
else()
    message(STATUS "Looking for doxygen - not found")
    message(STATUS "  Disabled making of documentation.")
endif()

#-----------------------------------------------------------------------------
message(STATUS "Configuring documentation - done")


#-----------------------------------------------------------------------------

=== test/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake config
#
#  protozero tests
#
#-----------------------------------------------------------------------------

include_directories(SYSTEM "${CMAKE_CURRENT_SOURCE_DIR}/catch")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")

set(TEST_DIRS alignment
              basic
              bool
              bytes
              complex
              data_view
              double
              endian
              enum
              exceptions
              fixed32
              fixed64
              float
              int32
              int64
              message
              nested
              repeated
              repeated_packed_bool
              repeated_packed_double
              repeated_packed_enum
              repeated_packed_fixed32
              repeated_packed_fixed64
              repeated_packed_float
              repeated_packed_int32
              repeated_packed_int64
              repeated_packed_sfixed32
              repeated_packed_sfixed64
              repeated_packed_sint32
              repeated_packed_sint64
              repeated_packed_uint32
              repeated_packed_uint64
              rollback
              sfixed32
              sfixed64
              sint32
              sint64
              skip
              string
              tag_and_type
              tags
              uint32
              uint64
              varint
              vector_tile
              wrong_type_access
              zigzag)

string(REGEX REPLACE "([^;]+)" "t/\\1/reader_test_cases.cpp" _test_sources "${TEST_DIRS}")

add_executable(reader_tests reader_tests.cpp ${_test_sources})

add_test(NAME reader_tests COMMAND reader_tests)

set_tests_properties(reader_tests PROPERTIES WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}")

if(PROTOBUF_FOUND)
    message(STATUS "Found protobuf libraries: Adding writer tests...")

    include_directories(SYSTEM ${PROTOBUF_INCLUDE_DIRS} ${CMAKE_CURRENT_BINARY_DIR})

    set(PROTOBUF_GENERATE_CPP_APPEND_PATH false)

    foreach(_dir IN LISTS TEST_DIRS)
        set(_full_src_dir "${CMAKE_CURRENT_SOURCE_DIR}/t/${_dir}")
        if(EXISTS "${_full_src_dir}/writer_test_cases.cpp")
            message(STATUS "  Adding ${_dir}")
            set(_full_bin_dir "${CMAKE_CURRENT_BINARY_DIR}/t/${_dir}")
            set(_proto_file "${_full_src_dir}/${_dir}_testcase.proto")
            set(_src_file "${_full_bin_dir}/${_dir}_testcase.pb.cc")
            set(_hdr_file "${_full_bin_dir}/${_dir}_testcase.pb.h")

            file(MAKE_DIRECTORY ${_full_bin_dir})

            list(APPEND SOURCES     "${_full_src_dir}/writer_test_cases.cpp")
            list(APPEND PROTO_FILES "${_proto_file}")
            list(APPEND PROTO_SRCS  "${_src_file}")
            list(APPEND PROTO_HDRS  "${_hdr_file}")

            set_source_files_properties(${_proto_file} ${_hdr_file}
                                        PROPERTIES GENERATED TRUE)

            add_custom_command(
                OUTPUT ${_src_file} ${_hdr_file}
                COMMAND ${PROTOBUF_PROTOC_EXECUTABLE}
                ARGS --cpp_out=${_full_bin_dir} -I ${_full_src_dir} ${_proto_file}
                DEPENDS ${_proto_file}
                VERBATIM)
        endif()
    endforeach()

    add_executable(writer_tests writer_tests.cpp ${SOURCES} ${PROTO_SRCS} ${PROTO_HDRS})

    target_link_libraries(writer_tests ${PROTOBUF_LITE_LIBRARY})

    if(NOT MSVC)
        set_target_properties(writer_tests PROPERTIES COMPILE_FLAGS "-pthread")
        if(NOT APPLE)
            set_target_properties(writer_tests PROPERTIES LINK_FLAGS "-pthread")
        endif()
    endif()

    add_test(NAME writer_tests COMMAND writer_tests)
else()
    message(STATUS "Protobuf libraries not found: Disabling writer tests.")
endif()


#-----------------------------------------------------------------------------

=== debian/changelog ===
protozero (1.6.1-1) unstable; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 16 Nov 2017 18:36:28 +0100

protozero (1.6.0-1) unstable; urgency=medium

  * New upstream release.
  * Add cmake to build dependencies.
  * Update packaging for cmake build.
  * Bump Standards-Version to 4.1.1, no changes.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 24 Oct 2017 20:08:16 +0200

protozero (1.5.3-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.1.0, no changes.
  * Update path for catch.hpp in copyright file.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 22 Sep 2017 16:49:40 +0200

=== debian/control ===
--- 
+++ 
@@ -4,12 +4,13 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper (>= 9),
+               cmake (>= 2.8),
                doxygen,
                graphviz,
                libprotobuf-dev,
                protobuf-compiler,
                pkg-config
-Standards-Version: 4.0.0
+Standards-Version: 4.1.1
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/protozero.git/
 Vcs-Git: https://anonscm.debian.org/git/pkg-grass/protozero.git
 Homepage: https://github.com/mapbox/protozero

=== debian/rules ===
--- 
+++ 
@@ -10,13 +10,11 @@
 %:
 	dh $@ --parallel
 
-override_dh_auto_build-arch:
-	dh_auto_build --arch
+override_dh_auto_build:
+	dh_auto_build
 
-override_dh_auto_build-indep:
-	$(MAKE) doc
 	# Remove useless autogenerated doxygen files
-	$(RM) doc/html/*.md5
+	$(RM) obj-*/doc/html/*.md5
 
 override_dh_auto_test:
 # Ignore test failures on problematic architectures only
@@ -26,9 +24,6 @@
 	dh_auto_test
 endif
 
-override_dh_auto_install:
-	dh_auto_install --destdir=$(CURDIR)/debian/tmp/usr
-
 override_dh_install:
 	dh_install --list-missing

=== debian/watch ===
version=3
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,\
filenamemangle=s/(?:.*\/)?(?:rel|v|protozero)[\-\_]?(\d[\d\-\.]*)\.(tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))/protozero-$1.$2/ \
https://github.com/mapbox/protozero/releases \
(?:.*/)?(?:rel|v|protozero)[\-\_]?(\d[\d\-\.]+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## protozero 1.6.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,7 +14,7 @@
 
 set(PROTOZERO_VERSION_MAJOR 1)
 set(PROTOZERO_VERSION_MINOR 6)
-set(PROTOZERO_VERSION_PATCH 1)
+set(PROTOZERO_VERSION_PATCH 2)
 
 set(PROTOZERO_VERSION
     "${PROTOZERO_VERSION_MAJOR}.${PROTOZERO_VERSION_MINOR}.${PROTOZERO_VERSION_PATCH}")
@@ -58,7 +58,7 @@
 #
 #-----------------------------------------------------------------------------
 message(STATUS "Looking for clang-tidy")
-find_program(CLANG_TIDY NAMES clang-tidy clang-tidy-5.0)
+find_program(CLANG_TIDY NAMES clang-tidy clang-tidy-6.0 clang-tidy-5.0)
 
 if(CLANG_TIDY)
     message(STATUS "Looking for clang-tidy - found ${CLANG_TIDY}")
@@ -66,8 +66,8 @@
         ${CLANG_TIDY}
         -p ${CMAKE_BINARY_DIR}
         ${CMAKE_SOURCE_DIR}/test/*.cpp
-        ${CMAKE_SOURCE_DIR}/test/t/*/reader_test_cases.cpp
-        ${CMAKE_SOURCE_DIR}/test/t/*/writer_test_cases.cpp
+        ${CMAKE_SOURCE_DIR}/test/t/*/*.cpp
+        ${CMAKE_SOURCE_DIR}/test/unit/*.cpp
         ${CMAKE_SOURCE_DIR}/tools/*.cpp
     )
     add_dependencies(clang-tidy writer_tests)
@@ -94,6 +94,7 @@
         ${CMAKE_SOURCE_DIR}/test/*.cpp
         ${CMAKE_SOURCE_DIR}/test/include/*.hpp
         ${CMAKE_SOURCE_DIR}/test/t/*/*.cpp
+        ${CMAKE_SOURCE_DIR}/test/unit/*.cpp
         ${CMAKE_SOURCE_DIR}/tools/*.cpp
     )
 else()

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -9,16 +9,14 @@
 include_directories(SYSTEM "${CMAKE_CURRENT_SOURCE_DIR}/catch")
 include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
 
+add_subdirectory(unit)
+
 set(TEST_DIRS alignment
-              basic
               bool
               bytes
               complex
-              data_view
               double
-              endian
               enum
-              exceptions
               fixed32
               fixed64
               float
@@ -52,10 +50,8 @@
               tags
               uint32
               uint64
-              varint
               vector_tile
-              wrong_type_access
-              zigzag)
+              wrong_type_access)
 
 string(REGEX REPLACE "([^;]+)" "t/\\1/reader_test_cases.cpp" _test_sources "${TEST_DIRS}")

=== test/unit/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake config
#
#  protozero unit tests
#
#-----------------------------------------------------------------------------

set(UNIT_TESTS data_view
               basic
               endian
               exceptions
               varint
               zigzag)

string(REGEX REPLACE "([^;]+)" "test_\\1.cpp" _test_sources "${UNIT_TESTS}")

add_executable(unit_tests main.cpp ${_test_sources})

add_test(NAME unit_tests COMMAND unit_tests)


#-----------------------------------------------------------------------------

=== debian/changelog ===
protozero (1.6.2-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 15 Mar 2018 06:55:58 +0100

protozero (1.6.2-1) unstable; urgency=medium

  * New upstream release.
  * Update copyright-format URL to use HTTPS.
  * Don't use libjs-jquery for Doxygen docs.
  * Bump Standards-Version to 4.1.3, no changes.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 09 Mar 2018 20:39:21 +0100

protozero (1.6.1-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 22 Nov 2017 07:21:15 +0100

protozero (1.6.0-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 30 Oct 2017 07:26:37 +0100

protozero (1.5.3-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 28 Sep 2017 07:44:51 +0200

protozero (1.5.2-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.
  * Update branch in gbp.conf & Vcs-Git URL.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 31 Aug 2017 11:00:03 +0200

=== debian/control ===
--- 
+++ 
@@ -10,9 +10,9 @@
                libprotobuf-dev,
                protobuf-compiler,
                pkg-config
-Standards-Version: 4.1.1
+Standards-Version: 4.1.3
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/protozero.git/
-Vcs-Git: https://anonscm.debian.org/git/pkg-grass/protozero.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-grass/protozero.git -b stretch-backports
 Homepage: https://github.com/mapbox/protozero
 
 Package: libprotozero-dev
@@ -40,8 +40,7 @@
 Package: libprotozero-doc
 Architecture: all
 Section: doc
-Depends: libjs-jquery,
-         ${misc:Depends}
+Depends: ${misc:Depends}
 Description: Minimalistic protocol buffer decoder and encoder in C++ - docs
  protozero is a minimalistic protocol buffer decoder and encoder in C++.
  .

## protozero 1.6.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,7 +14,7 @@
 
 set(PROTOZERO_VERSION_MAJOR 1)
 set(PROTOZERO_VERSION_MINOR 6)
-set(PROTOZERO_VERSION_PATCH 2)
+set(PROTOZERO_VERSION_PATCH 3)
 
 set(PROTOZERO_VERSION
     "${PROTOZERO_VERSION_MAJOR}.${PROTOZERO_VERSION_MINOR}.${PROTOZERO_VERSION_PATCH}")

=== debian/changelog ===
protozero (1.6.3-2) unstable; urgency=medium

  * Drop autopkgtest to test installability.
  * Add lintian override for testsuite-autopkgtest-missing.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 01 Aug 2018 16:38:06 +0200

protozero (1.6.3-1) unstable; urgency=medium

  * New upstream release.
  * Update Vcs-* URLs for Salsa.
  * Bump Standards-Version to 4.1.5, no changes.
  * Strip trailing whitespace from control & rules files.
  * Use filter instead of findstring to prevent partial matches.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 17 Jul 2018 18:17:35 +0200

=== debian/control ===
--- 
+++ 
@@ -10,9 +10,9 @@
                libprotobuf-dev,
                protobuf-compiler,
                pkg-config
-Standards-Version: 4.1.3
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/protozero.git/
-Vcs-Git: https://anonscm.debian.org/git/pkg-grass/protozero.git -b stretch-backports
+Standards-Version: 4.1.5
+Vcs-Browser: https://salsa.debian.org/debian-gis-team/protozero/
+Vcs-Git: https://salsa.debian.org/debian-gis-team/protozero.git
 Homepage: https://github.com/mapbox/protozero
 
 Package: libprotozero-dev
@@ -55,4 +55,3 @@
  Protobufs protoc program.
  .
  This package contains the protozero documentation.
-

## protozero 1.6.5

=== debian/changelog ===
protozero (1.6.5-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.3.0, no changes.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 06 Feb 2019 16:25:11 +0100

protozero (1.6.4-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.2.1, no changes.
  * Update watch file to limit matches to archive path.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 08 Nov 2018 17:45:31 +0100

## protozero 1.6.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,7 +14,7 @@
 
 set(PROTOZERO_VERSION_MAJOR 1)
 set(PROTOZERO_VERSION_MINOR 6)
-set(PROTOZERO_VERSION_PATCH 3)
+set(PROTOZERO_VERSION_PATCH 7)
 
 set(PROTOZERO_VERSION
     "${PROTOZERO_VERSION_MAJOR}.${PROTOZERO_VERSION_MINOR}.${PROTOZERO_VERSION_PATCH}")
@@ -26,7 +26,7 @@
 option(WERROR "Add -Werror flag to build (turns warnings into errors)" ON)
 
 if(MSVC)
-    add_definitions(-std=c++11 /W3)
+    add_definitions(/W3)
     add_definitions(-D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS)
 else()
     add_definitions(-std=c++11 -Wall -Wextra -pedantic -Wsign-compare -Wunused-parameter -Wno-float-equal -Wno-covered-switch-default)

=== test/unit/CMakeLists.txt ===
--- 
+++ 
@@ -10,6 +10,7 @@
                basic
                endian
                exceptions
+               iterators
                varint
                zigzag)

=== debian/changelog ===
protozero (1.6.7-1) unstable; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 21 Feb 2019 12:00:42 +0100

protozero (1.6.6-1) unstable; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 21 Feb 2019 06:56:30 +0100

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
                libprotobuf-dev,
                protobuf-compiler,
                pkg-config
-Standards-Version: 4.1.5
+Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/protozero/
 Vcs-Git: https://salsa.debian.org/debian-gis-team/protozero.git
 Homepage: https://github.com/mapbox/protozero

=== debian/rules ===
--- 
+++ 
@@ -18,7 +18,7 @@
 
 override_dh_auto_test:
 # Ignore test failures on problematic architectures only
-ifneq (,$(findstring $(DEB_BUILD_ARCH),"armhf"))
+ifneq (,$(filter $(DEB_BUILD_ARCH),armhf))
 	dh_auto_test || echo "Ignoring test failures"
 else
 	dh_auto_test
@@ -29,4 +29,3 @@
 
 override_dh_installchangelogs:
 	dh_installchangelogs CHANGELOG.md
-

## protozero 1.6.8

=== debian/changelog ===
protozero (1.6.8-1ubuntu2) groovy; urgency=medium

  * Force building with -O2, see
    https://github.com/mapbox/protozero/issues/101

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Jun 2020 10:39:20 +0200

protozero (1.6.8-1) unstable; urgency=medium

  * New upstream release.
  * Update gbp.conf to use --source-only-changes by default.
  * Bump Standards-Version to 4.4.0, no changes.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 15 Aug 2019 15:26:03 +0200

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
                libprotobuf-dev,
                protobuf-compiler,
                pkg-config
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/protozero/
 Vcs-Git: https://salsa.debian.org/debian-gis-team/protozero.git
 Homepage: https://github.com/mapbox/protozero

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,10 @@
 
 # Verbose make output
 export VERBOSE=1
+
+# see https://github.com/mapbox/protozero/issues/101
+export DEB_CXXFLAGS_MAINT_STRIP = -O3
+export DEB_CXXFLAGS_MAINT_APPEND = -O2
 
 DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

## protozero 1.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,8 +13,8 @@
 project(protozero)
 
 set(PROTOZERO_VERSION_MAJOR 1)
-set(PROTOZERO_VERSION_MINOR 6)
-set(PROTOZERO_VERSION_PATCH 7)
+set(PROTOZERO_VERSION_MINOR 7)
+set(PROTOZERO_VERSION_PATCH 0)
 
 set(PROTOZERO_VERSION
     "${PROTOZERO_VERSION_MAJOR}.${PROTOZERO_VERSION_MINOR}.${PROTOZERO_VERSION_PATCH}")
@@ -58,7 +58,7 @@
 #
 #-----------------------------------------------------------------------------
 message(STATUS "Looking for clang-tidy")
-find_program(CLANG_TIDY NAMES clang-tidy clang-tidy-6.0 clang-tidy-5.0)
+find_program(CLANG_TIDY NAMES clang-tidy clang-tidy-10 clang-tidy-9 clang-tidy-8 clang-tidy-7 clang-tidy-6.0 clang-tidy-5.0)
 
 if(CLANG_TIDY)
     message(STATUS "Looking for clang-tidy - found ${CLANG_TIDY}")
@@ -66,7 +66,8 @@
         ${CLANG_TIDY}
         -p ${CMAKE_BINARY_DIR}
         ${CMAKE_SOURCE_DIR}/test/*.cpp
-        ${CMAKE_SOURCE_DIR}/test/t/*/*.cpp
+        ${CMAKE_SOURCE_DIR}/test/t/*/reader_test_cases.cpp
+        ${CMAKE_SOURCE_DIR}/test/t/*/writer_test_cases.cpp
         ${CMAKE_SOURCE_DIR}/test/unit/*.cpp
         ${CMAKE_SOURCE_DIR}/tools/*.cpp
     )

=== tools/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake config
#
#  protozero tools
#
#-----------------------------------------------------------------------------

# Needs getopt, which is not available on Windows
if(NOT MSVC)
    add_executable(pbf-decoder pbf-decoder.cpp)

    add_test(NAME pbf-decoder-no-args
             COMMAND pbf-decoder)
    set_tests_properties(pbf-decoder-no-args PROPERTIES
                         PASS_REGULAR_EXPRESSION "^Usage:")

    add_test(NAME pbf-decoder-help
             COMMAND pbf-decoder --help)
    set_tests_properties(pbf-decoder-help PROPERTIES
                         PASS_REGULAR_EXPRESSION "^Usage:")

    add_test(NAME pbf-decoder-empty
             COMMAND pbf-decoder "${CMAKE_SOURCE_DIR}/test/t/message/data-opt-empty.pbf")
    set_tests_properties(pbf-decoder-empty PROPERTIES
                         PASS_REGULAR_EXPRESSION "^$")

    add_test(NAME pbf-decoder-data
             COMMAND pbf-decoder "${CMAKE_SOURCE_DIR}/test/t/message/data-message.pbf")
    set_tests_properties(pbf-decoder-data PROPERTIES
                         PASS_REGULAR_EXPRESSION "^1:")

    add_test(NAME pbf-decoder-vt
             COMMAND pbf-decoder -l 999999 -o 0 "${CMAKE_SOURCE_DIR}/test/t/vector_tile/data.vector.pbf")
    set_tests_properties(pbf-decoder-vt PROPERTIES
                         PASS_REGULAR_EXPRESSION "^3:")

    add_test(NAME pbf-decoder-fail
             COMMAND pbf-decoder -l 1 "${CMAKE_SOURCE_DIR}/test/t/vector_tile/data.vector.pbf")
    set_tests_properties(pbf-decoder-fail PROPERTIES
                         WILL_FAIL true)

    add_test(NAME pbf-decoder-fail-msg
             COMMAND pbf-decoder -l 1 "${CMAKE_SOURCE_DIR}/test/t/vector_tile/data.vector.pbf")
    set_tests_properties(pbf-decoder-fail-msg PROPERTIES
                         PASS_REGULAR_EXPRESSION "^end of buffer exception")

endif()


#-----------------------------------------------------------------------------

=== debian/changelog ===
protozero (1.7.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.5.0, no changes.
  * Drop Name field from upstream metadata.
  * Bump debhelper compat to 10, changes:
    - Drop --parallel option, enabled by default
  * Update copyright years for Two Blue Cubes Ltd.
  * Add patch to fix privacy-breach lintian issues.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 08 Jun 2020 15:38:54 +0200

=== debian/control ===
--- 
+++ 
@@ -3,14 +3,14 @@
 Uploaders: Bas Couwenberg <sebastic@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10~),
                cmake (>= 2.8),
                doxygen,
                graphviz,
                libprotobuf-dev,
                protobuf-compiler,
                pkg-config
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/protozero/
 Vcs-Git: https://salsa.debian.org/debian-gis-team/protozero.git
 Homepage: https://github.com/mapbox/protozero

=== debian/rules ===
--- 
+++ 
@@ -5,14 +5,10 @@
 # Verbose make output
 export VERBOSE=1
 
-# see https://github.com/mapbox/protozero/issues/101
-export DEB_CXXFLAGS_MAINT_STRIP = -O3
-export DEB_CXXFLAGS_MAINT_APPEND = -O2
-
 DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
 
 %:
-	dh $@ --parallel
+	dh $@
 
 override_dh_auto_build:
 	dh_auto_build

=== debian/watch ===
version=3
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,\
filenamemangle=s/(?:.*\/)?(?:rel|v|protozero)[\-\_]?(\d[\d\-\.]*)\.(tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))/protozero-$1.$2/ \
https://github.com/mapbox/protozero/releases \
(?:.*?/archive/)?(?:rel|v|protozero)[\-\_]?(\d[\d\-\.]+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
